var adPlugin = null;

function skipAd() {
    console.log("skipAd called!");
    if(adPlugin){
        adPlugin.skipAd();
    }
}


function startAdSlot() {
    console.log("startAdSlot called!");
    if (adPlugin) {
        adPlugin.startAdSlot();
    }
}

function hasClickThrough() {
    return adPlugin && adPlugin.hasClickThrough;
}

function clickThrough() {
    if (adPlugin) {
        return adPlugin.clickThrough(true);
    }
    return null;
}

function getAdInfo() {
    if (adPlugin) {
        return JSON.stringify(adPlugin.adInfo);
    }
    return null;
}

function getPublicAd() {
    if (adPlugin) {
        return JSON.stringify(adPlugin.ad);
    }
    return null;
}

function getPublicAdSlot() {
    if (adPlugin) {
        return JSON.stringify(adPlugin.adSlot);
    }
    return null;
}

function getAdVerification() {
    if (adPlugin) {
        return JSON.stringify(adPlugin.adVerifications);
    }
    return null;
}

function getError() {
    if (adPlugin) {
        return JSON.stringify(adPlugin.error);
    }
    return null;
}

function playAdWithURL(adURL, autoPlay, openerURL, forceOpener, closerURL, forceCloser, bumperURL, forceBumper, environmentVarsJSON, skipOffset) {
    console.log("playAdWithURL(adTag=" + adURL + ", autoPlay=" + autoPlay + ", opener="+ openerURL + ", forceOpener=" + forceOpener + ", closer=" + closerURL + ", forceCloser=" + forceCloser + ", bumper=" + bumperURL + ", forceBumper=" + forceBumper + ", envVars" + environmentVarsJSON + ", skipOffset=" + skipOffset + ")");
    var skipOffsetInt = parseInt(skipOffset);
    if (skipOffsetInt > 0) {
        globalAdConfig.skipOffset = skipOffsetInt;
    }
    var connectResult = smartclientcore.connect(playerProxy);
    if (connectResult) {
        connectResult.setup(globalAdConfig).then(api => {
            adPlugin = api;

            /**
             * You are ready to request your first ads
             * this is also a good point to subscribe to ad events
             */
            smartclientcore.EVENTS.forEach(eventType => {
            adPlugin.addEventListener(eventType, (event) => {
                     console.log("Calling event with eventType: " + eventType);
                     Android.onEventCallback(JSON.stringify(event));
                 });
            });

             var config = {
                 tag: adURL
             };
             if (openerURL != "null") {
                 config.opener = {
                     progressive: openerURL
                 }
             };
             if (closerURL != "null") {
                 config.closer = {
                     progressive: closerURL
                 }
             };
             if (bumperURL != "null") {
                 config.bumper = {
                     progressive: bumperURL
                 }
             };
             adPlugin.initAdSlot(config, JSON.parse(environmentVarsJSON)).then(function(adLoaded) {
                                        console.log('### Loading AdManifest success.');
                                        Android.onAdTagLoaded(autoPlay)
                                }, function(failedLoading) {
                                        console.log('### Loading AdManifest failed');
                                });

            }, failure => {
                console.log("Error: ", failure);
            });
        } else {
            console.log("Error: connection error. connect returned null");
        }
}