var UrlHandler = function() {};

UrlHandler.prototype.xhr = function() {
	return new window.XMLHttpRequest;
};

UrlHandler.supported = function() {
	return !!(new UrlHandler).xhr();
};

/**
 * Is used as a proxy for all external url requests from the core.
 * Notifies the Android component for every request.
 */
UrlHandler.prototype.get = function(url, options, cb) {
    Android.onCoreRequestedUrl(url)
	try {
		var xhr = this.xhr();
		xhr.open("GET", url);
		xhr.timeout = options.timeout || 0;
		if (xhr.overrideMimeType) {
			xhr.overrideMimeType("text/xml");
		}
		xhr.onreadystatechange = function() {
			if (xhr.readyState === 4) {
				if (xhr.status === 200) {
					var responseXML = xhr.responseXML;
					if (!responseXML && xhr.responseText) {
						responseXML = (new DOMParser).parseFromString(xhr.responseText, "application/xml");
					}
					if (!responseXML) {
						xhr.statusText = "Response contains neither 'responseXML' nor 'responseText'";
						cb(new Error("XHRURLHandler: " + xhr.statusText));
						return;
					}
					cb(null, responseXML);
				} else {
					cb(new Error("XHRURLHandler: " + xhr.statusText));
				}
			}
		};
		xhr.send();
	} catch (e) {
	    Android.onRequestUrlFailed(url, e)
		cb(e);
	}
};
